#pragma semicolon 1

#include <sourcemod>
#include <vip>

public Plugin:myinfo = 
{
	name	= "VIP [Gravity]",
	author	= "wS",
	version = "1.2.2"
};

#define ITEM_NAME "gravity"
new Float:g_fGravity[MAXPLAYERS + 1], Handle:g_hTimer = INVALID_HANDLE;

public OnPluginStart()
{
	if (!VIP_RegisterItem(ITEM_NAME, VIP_ITEM_TOGGLE)) SetFailState("VIP_RegisterItem error (%s)", ITEM_NAME);
	LoadTranslations("vip_modules_description.phrases");
	VIP_HookEvent(VE_Spawn, OnClientSpawn);

	///
	new Handle:hCvar = CreateConVar("vip_gravity_timer", "1.0", "Устанавливать гравитацию каждые 'x' сек (0 = не использовать таймер)");
	new Float:s = GetConVarFloat(hCvar);
	if (s > 0.0) g_hTimer = CreateTimer(s, g_hTimer_CallBack, _, TIMER_REPEAT);
	HookConVarChange(hCvar, cvar_changed);
	AutoExecConfig(true, "gravity", "vip/modules/gravity");
	///
}

public cvar_changed(Handle:hCvar, const String:OldValue[], const String:NewValue[])
{
	new Float:s = StringToFloat(NewValue);
	if (g_hTimer) KillTimer(g_hTimer);
	g_hTimer = s > 0.0 ? CreateTimer(s, g_hTimer_CallBack, _, TIMER_REPEAT) : INVALID_HANDLE;
}

///////////////////////////////////////////////////////////////////////////////////

public bool:VIP_CurrentItemValue(client, ItemID, String:ItemValue[], ItemValueSize)
{
	if (g_fGravity[client])
	{
		FormatEx(ItemValue, ItemValueSize, "%.2f", g_fGravity[client]);
		return true;
	}
	ItemValue[0] = 0;
	return false;
}

public bool:VIP_Description(client, ItemID, String:ItemValue[ITEM_INFO_LENGTH], String:description[], description_size)
{
	FormatEx(description, description_size, "%T", ITEM_NAME, client, StringToFloat(ItemValue));
	return true;
}

public VipGiveAction:VIP_GiveAccess(client, ItemID, String:ItemValue[ITEM_INFO_LENGTH], bool:bCallAfterAdminAction, CURRENT_ACCESS, Handle:kv)
{
	return UpdateAccess(client, ItemValue);
}

stock VipGiveAction:UpdateAccess(client, String:ItemValue[ITEM_INFO_LENGTH])
{
	if (!ItemValue[0])
		return VGA_ValueNotSpecified;
										
	new Float:fValue = StringToFloat(ItemValue);
	if (fValue <= 0.0)
		return VGA_BadValue;

	if (fValue < 0.1) fValue = 0.1;
	else if (fValue > 5.0) fValue = 5.0;
	
	if (fValue == g_fGravity[client])
		return VGA_SameValue;
	
	g_fGravity[client] = fValue;
	if (IsPlayerAlive(client)) SetEntityGravity(client, fValue);
	
	FormatEx(ItemValue, ITEM_INFO_LENGTH, "%.2f", fValue);
	VIP_NotifyItemStatusChanged(client, ITEM_NAME, true, ItemValue, 16);

	return VGA_Continue;
}

public VIP_TakeAccess(client, ItemID, bool:bToggledByClient)
{
	g_fGravity[client] = 0.0;
	SetEntityGravity(client, 1.0);
	VIP_NotifyItemStatusChanged(client, ITEM_NAME, false);
}

public OnPluginPauseChange(bool:pause) { if (pause) VIP_TakeAccessAll(); }
public OnPluginEnd() VIP_TakeAccessAll();

stock VIP_TakeAccessAll() // Если функция у игрока активна, то нужно её отключить.
{
	for (new client = 1; client <= MaxClients; client++)
	{
		if (g_fGravity[client] && IsClientInGame(client))
			VIP_TakeAccess(client, 0, false);
	}
}

///////////////////////////////////////////////////////////////////////////////////

public OnClientSpawn(client, team)
{
	if (g_fGravity[client])
		SetEntityGravity(client, g_fGravity[client]);
}

public Action:g_hTimer_CallBack(Handle:timer)
{
	for (new client = 1; client <= MaxClients; client++)
	{
		if (g_fGravity[client] && IsClientInGame(client) && IsPlayerAlive(client))
			SetEntityGravity(client, g_fGravity[client]);
	}
	return Plugin_Continue;
}

public OnClientDisconnect(client)
	g_fGravity[client] = 0.0;